#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeB.h>
#include <Xm/ScrollBar.h>
#include <Xm/RowColumn.h>
#include <Xm/MenuShell.h>
#include <Xm/Form.h>
#include <Xm/ArrowB.h>
#include <Xm/DrawingA.h>

#include "../include/common.h"
#include "lists.h"
#include "robem_def.h"
#include "robem.h"

void create_colorscreen () {
  // function name: create_colorscreen
  // Create/initialize color map screen
  
  int *tag1, *tag2, *tag3, *tag4, *tag5, *tag6, *tag7, *tag8, *tag9, *tag10;
  int *tag11, *tag12, *tag13, *tag14, *tag15;
  int *tag16, *tag17, *tag18, *tag19, *tag20;
  int *tag21, *tag22, *tag23, *tag24;

  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));
  tag4 = (int *) malloc(sizeof(int));
  tag5 = (int *) malloc(sizeof(int));
  tag6 = (int *) malloc(sizeof(int));
  tag7 = (int *) malloc(sizeof(int));
  tag8 = (int *) malloc(sizeof(int));
  tag9 = (int *) malloc(sizeof(int));
  tag10 = (int *) malloc(sizeof(int));
  tag11 = (int *) malloc(sizeof(int));
  tag12 = (int *) malloc(sizeof(int));
  tag13 = (int *) malloc(sizeof(int));
  tag14 = (int *) malloc(sizeof(int));
  tag15 = (int *) malloc(sizeof(int));
  tag16 = (int *) malloc(sizeof(int));
  tag17 = (int *) malloc(sizeof(int));
  tag18 = (int *) malloc(sizeof(int));
  tag19 = (int *) malloc(sizeof(int));
  tag20 = (int *) malloc(sizeof(int));
  tag21 = (int *) malloc(sizeof(int));
  tag22 = (int *) malloc(sizeof(int));
  tag23 = (int *) malloc(sizeof(int));
  tag24 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("Colormap Editor"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 100);
  XtSetArg(arglst[5], XmNy, 350);
  XtSetArg(arglst[6], XmNwidth, 510);
  XtSetArg(arglst[7], XmNheight, 620);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  colorScreenW = XmCreateFormDialog(toplevel_widget, "clr", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 50);
  XtSetArg(arglst[4], XmNy, 50);
  colorExitW = XmCreatePushButton(colorScreenW, "clr_exit", arglst, 5);
  XtAddCallback(colorExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(colorExitW);

  // First set of colormap toggles
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNx, 200);
  XtSetArg(arglst[3], XmNy, 15);
  colorRadio1W = XmCreateRadioBox(colorScreenW, "clr_rad1", arglst, 4);
  XtManageChild(colorRadio1W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Normal Grayscale"));
  XtSetArg(arglst[1], XmNset, 1);
  colorGnW = XmCreateToggleButton(colorRadio1W, "clr_gn", arglst, 2);
  *tag2 = USEGENERIC;
  XtAddCallback(colorGnW, XmNdisarmCallback, toggle_change, (XtPointer)tag2);
  XtManageChild(colorGnW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Reverse Contrast"));
  colorRvW = XmCreateToggleButton(colorRadio1W, "clr_rv", arglst, 1);
  *tag3 = USEREVERSE;
  XtAddCallback(colorRvW, XmNdisarmCallback, toggle_change, (XtPointer)tag3);
  XtManageChild(colorRvW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Local Contrast Stretching"));
  colorFtW = XmCreateToggleButton(colorRadio1W, "clr_ft", arglst, 1);
  *tag4 = USEFITTO;
  XtAddCallback(colorFtW, XmNdisarmCallback, toggle_change, (XtPointer)tag4);
  XtManageChild(colorFtW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Randomized"));
  colorRnW = XmCreateToggleButton(colorRadio1W, "clr_rn", arglst, 1);
  *tag5 = USERANDOM;
  XtAddCallback(colorRnW, XmNdisarmCallback, toggle_change, (XtPointer)tag5);
  XtManageChild(colorRnW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Build your own"));
  colorBdW = XmCreateToggleButton(colorRadio1W, "clr_bd", arglst, 1);
  *tag6 = USEBUILD;
  XtAddCallback(colorBdW, XmNdisarmCallback, toggle_change, (XtPointer)tag6);
  XtManageChild(colorBdW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Read from file"));
  colorRdW = XmCreateToggleButton(colorRadio1W, "clr_rd", arglst, 1);
  *tag7 = READCM;
  XtAddCallback(colorRdW, XmNdisarmCallback, toggle_change, (XtPointer)tag7);
  XtManageChild(colorRdW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Write to file"));
  colorWrW = XmCreateToggleButton(colorRadio1W, "clr_wr", arglst, 1);
  *tag8 = WRITECM;
  XtAddCallback(colorWrW, XmNdisarmCallback, toggle_change, (XtPointer)tag8);
  XtManageChild(colorWrW);

  // Second set of colormap toggles
  XtSetArg(arglst[0], XmNunitType, XmPIXELS);
  XtSetArg(arglst[1], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[2], XmNx, 10);
  XtSetArg(arglst[3], XmNy, 510);
  colorRadio2W = XmCreateRadioBox(colorScreenW, "clr_rad2", arglst, 4);
  XtManageChild(colorRadio2W);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("No Contrast Stretching (Global)"));
  XtSetArg(arglst[1], XmNset, 1);
  noContrastW = XmCreateToggleButton(colorRadio2W, "clr_nc", arglst, 2);
  *tag9 = NOCONTRAST;
  XtAddCallback(noContrastW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag9);
  XtManageChild(noContrastW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Contrast Stretch Scanned Images (Global)"));
  useContrastW = XmCreateToggleButton(colorRadio2W, "clr_cs", arglst, 1);
  *tag10 = USECONTRAST;
  XtAddCallback(useContrastW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag10);
  XtManageChild(useContrastW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("Histogram Equalization (Global)"));
  histEqualW = XmCreateToggleButton(colorRadio2W, "clr_he", arglst, 1);
  *tag11 = USEHISTEQUAL;
  XtAddCallback(histEqualW, XmNvalueChangedCallback, 
		histMode_change, (XtPointer)tag11);
  XtManageChild(histEqualW);

  // Red scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Red"));
  XtSetArg(arglst[1], XmNx, 295);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[RED] = XmCreateLabel(colorScreenW, "clr_rdl", arglst, 3);
  XtManageChild(colorLabelW[RED]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 295);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[RED] = XmCreateLabel(colorScreenW, "clr_rdv", arglst, 3);
  XtManageChild(colorValueW[RED]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 300);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[RED] = XmCreateScrollBar(colorScreenW, "clr_rds", arglst, 9);
  *tag12 = RED;
  XtManageChild(colorScrollW[RED]);
  XtAddCallback(colorScrollW[RED], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag12);
  XtAddCallback(colorScrollW[RED], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag12);

  // Green scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Grn"));
  XtSetArg(arglst[1], XmNx, 345);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[GREEN] = XmCreateLabel(colorScreenW, "clr_grl", arglst, 3);
  XtManageChild(colorLabelW[GREEN]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 345);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[GREEN] = XmCreateLabel(colorScreenW, "clr_grv", arglst, 3);
  XtManageChild(colorValueW[GREEN]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 350);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[GREEN] = XmCreateScrollBar(colorScreenW, "clr_grs", arglst, 9);
  *tag13 = GREEN;
  XtManageChild(colorScrollW[GREEN]);
  XtAddCallback(colorScrollW[GREEN], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag13);
  XtAddCallback(colorScrollW[GREEN], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag13);

  // Blue scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Blue"));
  XtSetArg(arglst[1], XmNx, 392);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[BLUE] = XmCreateLabel(colorScreenW, "clr_bll", arglst, 3);
  XtManageChild(colorLabelW[BLUE]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 395);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[BLUE] = XmCreateLabel(colorScreenW, "clr_blv", arglst, 3);
  XtManageChild(colorValueW[BLUE]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 400);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  colorScrollW[BLUE] = XmCreateScrollBar(colorScreenW, "clr_bls", arglst, 9);
  *tag14 = BLUE;
  XtManageChild(colorScrollW[BLUE]);
  XtAddCallback(colorScrollW[BLUE], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag14);
  XtAddCallback(colorScrollW[BLUE], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag14);

  // Bright scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Bright"));
  XtSetArg(arglst[1], XmNx, 438);
  XtSetArg(arglst[2], XmNy, 280);
  colorLabelW[BRIGHT] = XmCreateLabel(colorScreenW, "clr_brl", arglst, 3);
  XtManageChild(colorLabelW[BRIGHT]);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("255"));
  XtSetArg(arglst[1], XmNx, 445);
  XtSetArg(arglst[2], XmNy, 450);
  colorValueW[BRIGHT] = XmCreateLabel(colorScreenW, "clr_brv", arglst, 3);
  XtManageChild(colorValueW[BRIGHT]);

  XtSetArg(arglst[0], XmNmaximum, 283);
  XtSetArg(arglst[1], XmNminimum, 0);
  XtSetArg(arglst[2], XmNpageIncrement, 5);
  XtSetArg(arglst[3], XmNorientation, XmVERTICAL);
  XtSetArg(arglst[4], XmNx, 450);
  XtSetArg(arglst[5], XmNy, 300);
  XtSetArg(arglst[6], XmNheight, 150);
  XtSetArg(arglst[7], XmNwidth, 20);
  XtSetArg(arglst[8], XmNprocessingDirection, XmMAX_ON_TOP);
  XtSetArg(arglst[9], XmNvalue, 255);
  colorScrollW[BRIGHT] = XmCreateScrollBar(colorScreenW, "clr_brs", arglst, 10);
  *tag15 = BRIGHT;
  XtManageChild(colorScrollW[BRIGHT]);
  XtAddCallback(colorScrollW[BRIGHT], XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag15);
  XtAddCallback(colorScrollW[BRIGHT], XmNdragCallback, 
		colorScrollChange, (XtPointer)tag15);

  // Step scroll widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Steps:"));
  XtSetArg(arglst[1], XmNx, 20);
  XtSetArg(arglst[2], XmNy, 480);
  stepCMLabelW = XmCreateLabel(colorScreenW, "clr_cml", arglst, 3);
  XtManageChild(stepCMLabelW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized(" 256"));
  XtSetArg(arglst[1], XmNx, 195);
  XtSetArg(arglst[2], XmNy, 480);
  stepCMValueW = XmCreateLabel(colorScreenW, "clr_cmv", arglst, 3);
  XtManageChild(stepCMValueW);

  XtSetArg(arglst[0], XmNmaximum, 276);
  XtSetArg(arglst[1], XmNminimum, 1);
  XtSetArg(arglst[2], XmNpageIncrement, 20);
  XtSetArg(arglst[3], XmNorientation, XmHORIZONTAL);
  XtSetArg(arglst[4], XmNx, 90);
  XtSetArg(arglst[5], XmNy, 485);
  XtSetArg(arglst[6], XmNvalue, 256);
  XtSetArg(arglst[7], XmNsliderSize, 20);
  stepCMScrollW = XmCreateScrollBar(colorScreenW, "clr_cms", arglst, 8);
  *tag16 = STEPCM;
  XtManageChild(stepCMScrollW);
  XtAddCallback(stepCMScrollW, XmNvalueChangedCallback, 
		colorScrollChange, (XtPointer)tag16);
  XtAddCallback(stepCMScrollW, XmNdragCallback, 
		colorScrollChange, (XtPointer)tag16);

  // ramp and rainbow buttons + test color area
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Ramp"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 350);
  colorRampW = XmCreateToggleButton(colorScreenW, "clr_ramp", arglst, 3);
  *tag17 = TEST;
  XtAddCallback(colorRampW, XmNvalueChangedCallback, 
		colormap_ramp_change, (XtPointer)tag17);
  XtManageChild(colorRampW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("Rainbow"));
  XtSetArg(arglst[1], XmNx, 210);
  XtSetArg(arglst[2], XmNy, 380);
  colorRbowW = XmCreateToggleButton(colorScreenW, "clr_rbow", arglst, 3);
  *tag18 = RAINBOW;
  XtAddCallback(colorRbowW, XmNvalueChangedCallback, 
		colormap_ramp_change, (XtPointer)tag18);
  XtManageChild(colorRbowW);

  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 230);
  XtSetArg(arglst[2], XmNy, 410);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 32);
  testcolormapW = XmCreateDrawingArea(colorScreenW, "clr_tmap", arglst, 5);
  *tag19 = TEST;
  XtAddCallback(testcolormapW, XmNexposeCallback, 
		DrawTestColormapWindow, (XtPointer)tag19);
  XtManageChild(testcolormapW);

  // Histogram and associated widgets
  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 109);
  radialValueW = XmCreateLabel(colorScreenW, "clr_rvw", arglst, 3);
  XtManageChild(radialValueW);

  XtSetArg(arglst[0], XmNlabelString, XmStringCreateLocalized("  0"));
  XtSetArg(arglst[1], XmNx, 10);
  XtSetArg(arglst[2], XmNy, 365);
  colorValueW[ENTRY] = XmCreateLabel(colorScreenW, "clr_elw", arglst, 3);
  XtManageChild(colorValueW[ENTRY]);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 104);
  XtSetArg(arglst[3], XmNy, 378);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_RIGHT);
  colorHistUpW = XmCreateArrowButton(colorScreenW, "clr_hup", arglst, 5);
  *tag20 = XmARROW_UP;
  XtAddCallback(colorHistUpW, XmNactivateCallback, 
		histArrowActivate, (XtPointer)tag20);
  XtManageChild(colorHistUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 86);
  XtSetArg(arglst[3], XmNy, 378);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_LEFT);
  colorHistDnW = XmCreateArrowButton(colorScreenW, "clr_hdn", arglst, 5);
  *tag21 = XmARROW_DOWN;
  XtAddCallback(colorHistDnW, XmNactivateCallback, 
		histArrowActivate, (XtPointer)tag21);
  XtManageChild(colorHistDnW);
  
  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 50);
  XtSetArg(arglst[2], XmNy, 120);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 256);
  colormapW = XmCreateDrawingArea(colorScreenW, "clr_cmw", arglst, 5);
  XtAddCallback(colormapW, XmNexposeCallback, DrawColormapWindow, NULL);
  XtAddCallback(colormapW, XmNinputCallback, colorClick, NULL);
  XtManageChild(colormapW);
  
  XtSetArg(arglst[0], XmNborderWidth, 2);
  XtSetArg(arglst[1], XmNx, 84);
  XtSetArg(arglst[2], XmNy, 120);
  XtSetArg(arglst[3], XmNwidth, 32);
  XtSetArg(arglst[4], XmNheight, 256);
  histW = XmCreateDrawingArea(colorScreenW, "clr_hist2", arglst, 5);
  *tag22 = HIST;
  XtAddCallback(histW, XmNexposeCallback, 
		DrawTestColormapWindow, (XtPointer)tag22);
  XtAddCallback(histW, XmNinputCallback, colorClick, NULL);
  XtManageChild(histW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 120);
  XtSetArg(arglst[3], XmNy, 120);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_UP);
  colormapScrollW = XmCreateArrowButton(colorScreenW, "clr_sup", arglst, 5);
  *tag23 = XmARROW_UP;
  XtAddCallback(colormapScrollW, XmNactivateCallback, 
		colormap_scroll_activate, (XtPointer)tag23);
  XtManageChild(colormapScrollW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNx, 120);
  XtSetArg(arglst[3], XmNy, 358);
  XtSetArg(arglst[4], XmNarrowDirection, XmARROW_DOWN);
  colormapScrollDownW = XmCreateArrowButton(colorScreenW, "clr_sdn", arglst, 5);
  *tag24 = XmARROW_DOWN;
  XtAddCallback(colormapScrollDownW, XmNactivateCallback, 
		colormap_scroll_activate, (XtPointer)tag24);
  XtManageChild(colormapScrollDownW);

} // end function create_colorscreen
