#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/ArrowB.h>

#include "../include/common.h"
#include "lists.h"
#include "robem_def.h"
#include "robem.h"

void create_versionscreen () {
  // function name: create_versionscreen
  // Create/initialize version screen

  int *tag1, *tag2, *tag3;

  tag1 = (int *) malloc(sizeof(int));
  tag2 = (int *) malloc(sizeof(int));
  tag3 = (int *) malloc(sizeof(int));

  XtSetArg(arglst[0], XmNautoUnmanage, 0);
  XtSetArg(arglst[1], XmNdefaultPosition, 0);
  XtSetArg(arglst[2], XmNdialogTitle, 
	   XmStringCreateLocalized("File Version"));
  XtSetArg(arglst[3], XmNdialogStyle, XmDIALOG_MODELESS);
  XtSetArg(arglst[4], XmNx, 300);
  XtSetArg(arglst[5], XmNy, 120);
  XtSetArg(arglst[6], XmNwidth, 350);
  XtSetArg(arglst[7], XmNheight, 150);
  XtSetArg(arglst[8], XmNresizePolicy, XmRESIZE_NONE);
  versionScreenW = XmCreateFormDialog(toplevel_widget, "ver", arglst, 9);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 15);
  XtSetArg(arglst[4], XmNy, 100);
  versionExitW = XmCreatePushButton(versionScreenW, "ver_exit", arglst, 5);
  XtAddCallback(versionExitW, XmNactivateCallback, simple_deactivate, NULL);
  XtManageChild(versionExitW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 38);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 110);
  XtSetArg(arglst[4], XmNy, 100);
  versionScrollW = XmCreatePushButton(versionScreenW, "ver_scr", arglst, 5);
  *tag1 = SCROLL;
  XtAddCallback(versionScrollW, XmNactivateCallback, 
		version_scroll_activate, (XtPointer)tag1);
  XtManageChild(versionScrollW);

  XtSetArg(arglst[0], XmNlabelType, XmPIXMAP);
  XtSetArg(arglst[1], XmNwidth, 28);
  XtSetArg(arglst[2], XmNheight, 32);
  XtSetArg(arglst[3], XmNx, 185);
  XtSetArg(arglst[4], XmNy, 100);
  versionStopW = XmCreatePushButton(versionScreenW, "ver_stop", arglst, 5);
  XtManageChild(versionStopW);

  XtSetArg(arglst[0], XmNlabelString, 
	   XmStringCreateLocalized("File version #"));
  XtSetArg(arglst[1], XmNx, 15);
  XtSetArg(arglst[2], XmNy, 18);
  versionLabelW = XmCreateLabel(versionScreenW, "ver_lab", arglst, 3);
  XtManageChild(versionLabelW);

  XtSetArg(arglst[0], XmNcolumns,  7);
  XtSetArg(arglst[1], XmNx, 150);
  XtSetArg(arglst[2], XmNy, 15);
  versionTextW = XmCreateText(versionScreenW, "ver_txt", arglst, 3);
  XtManageChild(versionTextW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 15);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_UP);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, versionTextW);
  versionUpW = XmCreateArrowButton(versionScreenW, "ver_aup", arglst, 6);
  *tag2 = VERSIONUP;
  XtAddCallback(versionUpW, XmNactivateCallback, 
		generic_ArrowActivate, (XtPointer)tag2);
  XtManageChild(versionUpW);

  XtSetArg(arglst[0], XmNheight, 17);
  XtSetArg(arglst[1], XmNwidth, 20);
  XtSetArg(arglst[2], XmNy, 33);
  XtSetArg(arglst[3], XmNarrowDirection, XmARROW_DOWN);
  XtSetArg(arglst[4], XmNleftAttachment, XmATTACH_WIDGET);
  XtSetArg(arglst[5], XmNleftWidget, versionTextW);
  versionDownW = XmCreateArrowButton(versionScreenW, "ver_adn", arglst, 6);
  *tag3 = VERSIONDOWN;
  XtAddCallback(versionDownW, XmNactivateCallback, 
		generic_ArrowActivate, (XtPointer)tag3);
  XtManageChild(versionDownW);

} // end function create_versionstring
